diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java
index d23ba5ffc0..bbb72bb378 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TaxonServiceSearchTest.java
@@ -859,8 +1053,10 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         pager = taxonService.findByEverythingFullText("genus", null, null,  false, null, null, null, null); // --> 1
         Assert.assertEquals("Expecting 1 entity", Integer.valueOf(1), pager.getCount());
 
+        //FIXME FAILS: abies balamea is returned twice, see also testFullText_Grouping()
         pager = taxonService.findByEverythingFullText("Balsam-Tanne", null, Arrays.asList(new Language[]{Language.GERMAN()}), false, null, null, null, null);
-        Assert.assertEquals("expecting to find the GERMAN 'Balsam-Tanne'", Integer.valueOf(1), pager.getCount());
+        logPagerRecords(pager, Level.DEBUG);
+        Assert.assertEquals("expecting to find the Abies balsamea via the GERMAN DescriptionElements", Integer.valueOf(1), pager.getCount());
 
         pager = taxonService.findByEverythingFullText("Abies", null, null, true, null, null, null, null);
         Assert.assertEquals("Expecting 8 entities", Integer.valueOf(8), pager.getCount());
@@ -870,31 +1066,45 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         Assert.assertTrue("first fragments should contains serch term", fragments[0].toLowerCase().contains("<b>abies</b>"));
     }
 
-    /**
-     *
-     */
-    private void refreshLuceneIndex() {
-
-//        commitAndStartNewTransaction(null);
-        commit();
-        endTransaction();
-        indexer.purge(DefaultProgressMonitor.NewInstance());
-        indexer.reindex(DefaultProgressMonitor.NewInstance());
-        startNewTransaction();
-//        commitAndStartNewTransaction(null);
-    }
+//    @SuppressWarnings("rawtypes")
+//    @Test
+//    @DataSet
+//    public final void benchmarkFindTaxaAndNamesHql() throws CorruptIndexException, IOException, ParseException {
+//
+//        createRandomTaxonWithCommonName(NUM_OF_NEW_RADOM_ENTITIES);
+//
+//        IFindTaxaAndNamesConfigurator configurator = new FindTaxaAndNamesConfiguratorImpl();
+//        configurator.setTitleSearchString("Weiß%");
+//        configurator.setMatchMode(MatchMode.BEGINNING);
+//        configurator.setDoTaxa(false);
+//        configurator.setDoSynonyms(false);
+//        configurator.setDoNamesWithoutTaxa(false);
+//        configurator.setDoTaxaByCommonNames(true);
+//
+//        Pager<IdentifiableEntity> pager;
+//
+//        long startMillis = System.currentTimeMillis();
+//        for (int indx = 0; indx < BENCHMARK_ROUNDS; indx++) {
+//            pager = taxonService.findTaxaAndNames(configurator);
+//            if (logger.isDebugEnabled()) {
+//                logger.debug("[" + indx + "]" + pager.getRecords().get(0).getTitleCache());
+//            }
+//        }
+//        double duration = ((double) (System.currentTimeMillis() - startMillis)) / BENCHMARK_ROUNDS;
+//        logger.info("Benchmark result - [find taxon by CommonName via HQL] : " + duration + "ms (" + BENCHMARK_ROUNDS + " benchmark rounds )");
+//    }
 
     @SuppressWarnings("rawtypes")
     @Test
     @DataSet
-    public final void testFindByCommonNameHqlBenchmark() throws CorruptIndexException, IOException, ParseException {
+    public final void benchmarkFindByCommonNameHql() throws CorruptIndexException, IOException, ParseException {
 
 //        printDataSet(System.err, new String[] { "TaxonBase" });
 
         createRandomTaxonWithCommonName(NUM_OF_NEW_RADOM_ENTITIES);
 
         IFindTaxaAndNamesConfigurator configurator = new FindTaxaAndNamesConfiguratorImpl();
-        configurator.setTitleSearchString("Weiß%");
+        configurator.setTitleSearchString("Wei"+UTF8.SHARP_S+"%");
         configurator.setMatchMode(MatchMode.BEGINNING);
         configurator.setDoTaxa(false);
         configurator.setDoSynonyms(false);
@@ -917,9 +1127,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
     @SuppressWarnings("rawtypes")
     @Test
     @DataSet
-    public final void testFindByCommonNameLuceneBenchmark() throws CorruptIndexException, IOException, ParseException {
-
-//        printDataSet(System.err, new String[] { "TaxonBase" });
+    public final void benchmarkFindByCommonNameLucene() throws CorruptIndexException, IOException, ParseException {
 
         createRandomTaxonWithCommonName(NUM_OF_NEW_RADOM_ENTITIES);
 
@@ -929,7 +1137,7 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         long startMillis = System.currentTimeMillis();
         for (int indx = 0; indx < BENCHMARK_ROUNDS; indx++) {
-            pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Weiß*", null, null, null, false, null, null, null, null);
+            pager = taxonService.findByDescriptionElementFullText(CommonTaxonName.class, "Wei"+UTF8.SHARP_S+"*", null, null, null, false, null, null, null, null);
             if (logger.isDebugEnabled()) {
                 logger.debug("[" + indx + "]" + pager.getRecords().get(0).getEntity().getTitleCache());
             }
@@ -938,19 +1146,27 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         logger.info("Benchmark result - [find taxon by CommonName via lucene] : " + duration + "ms (" + BENCHMARK_ROUNDS + " benchmark rounds )");
     }
 
+    /**
+     * uncomment @Test annotation to create the dataset for this test
+     */
 //    @Test
     @DataSet(loadStrategy=CleanSweepInsertLoadStrategy.class, value="BlankDataSet.xml")
     public final void createDataSet() throws FileNotFoundException {
 
-        Classification classification = Classification.NewInstance("European Abies");
-        classification.setUuid(UUID.fromString(CLASSIFICATION_UUID));
+        Classification europeanAbiesClassification = Classification.NewInstance("European Abies");
+        europeanAbiesClassification.setUuid(UUID.fromString(CLASSIFICATION_UUID));
+        classificationService.save(europeanAbiesClassification);
+
         Classification alternativeClassification = Classification.NewInstance("Abies alternative");
-        classification.setUuid(UUID.fromString(CLASSIFICATION_ALT_UUID));
-        classificationService.save(classification);
+        alternativeClassification.setUuid(UUID.fromString(CLASSIFICATION_ALT_UUID));
         classificationService.save(alternativeClassification);
 
         Reference<?> sec = ReferenceFactory.newBook();
+        sec.setTitleCache("Kohlbecker, A., Testcase standart views, 2013", true);
+        Reference<?> sec_sensu = ReferenceFactory.newBook();
+        sec_sensu.setTitleCache("Komarov, V. L., Flora SSSR 29", true);
         referenceService.save(sec);
+        referenceService.save(sec_sensu);
 
         BotanicalName n_abies = BotanicalName.NewInstance(Rank.GENUS());
         n_abies.setNameCache("Abies", true);
@@ -962,10 +1178,16 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         Taxon t_abies_alba = Taxon.NewInstance(n_abies_alba, sec);
         taxonService.save(t_abies_alba);
 
+        BotanicalName n_abies_subalpina = BotanicalName.NewInstance(Rank.SPECIES());
+        n_abies_subalpina.setNameCache("Abies subalpina", true);
+        Synonym s_abies_subalpina = Synonym.NewInstance(n_abies_subalpina, sec);
+        taxonService.save(s_abies_subalpina);
+
         BotanicalName n_abies_balsamea = BotanicalName.NewInstance(Rank.SPECIES());
         n_abies_balsamea.setNameCache("Abies balsamea", true);
         Taxon t_abies_balsamea = Taxon.NewInstance(n_abies_balsamea, sec);
         t_abies_balsamea.setUuid(UUID.fromString(ABIES_BALSAMEA_UUID));
+        t_abies_balsamea.addSynonym(s_abies_subalpina, SynonymRelationshipType.SYNONYM_OF());
         taxonService.save(t_abies_balsamea);
 
         BotanicalName n_abies_grandis = BotanicalName.NewInstance(Rank.SPECIES());
@@ -979,55 +1201,109 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         t_abies_kawakamii.getTitleCache();
         taxonService.save(t_abies_kawakamii);
 
-        BotanicalName n_abies_subalpina = BotanicalName.NewInstance(Rank.SPECIES());
-        n_abies_subalpina.setNameCache("Abies subalpina", true);
-        Synonym s_abies_subalpina = Synonym.NewInstance(n_abies_subalpina, sec);
-        taxonService.save(s_abies_subalpina);
+        // abies_kawakamii_sensu_komarov as missapplied name for t_abies_balsamea
+        Taxon t_abies_kawakamii_sensu_komarov = Taxon.NewInstance(n_abies_kawakamii, sec_sensu);
+        taxonService.save(t_abies_kawakamii_sensu_komarov);
+        t_abies_kawakamii_sensu_komarov.addTaxonRelation(t_abies_balsamea, TaxonRelationshipType.MISAPPLIED_NAME_FOR(), null, null);
+        taxonService.saveOrUpdate(t_abies_kawakamii_sensu_komarov);
 
         BotanicalName n_abies_lasiocarpa = BotanicalName.NewInstance(Rank.SPECIES());
         n_abies_lasiocarpa.setNameCache("Abies lasiocarpa", true);
         Taxon t_abies_lasiocarpa = Taxon.NewInstance(n_abies_lasiocarpa, sec);
-        t_abies_lasiocarpa.addSynonym(s_abies_subalpina, SynonymRelationshipType.SYNONYM_OF());
         taxonService.save(t_abies_lasiocarpa);
 
         // add taxa to classifications
-        classification.addChildTaxon(t_abies_balsamea, null, null, null);
-        alternativeClassification.addChildTaxon(t_abies_lasiocarpa, null, null, null);
-        classificationService.saveOrUpdate(classification);
+        europeanAbiesClassification.addChildTaxon(t_abies_balsamea, null, null);
+        alternativeClassification.addChildTaxon(t_abies_lasiocarpa, null, null);
+        classificationService.saveOrUpdate(europeanAbiesClassification);
         classificationService.saveOrUpdate(alternativeClassification);
 
         //
         // Description
         //
         TaxonDescription d_abies_alba = TaxonDescription.NewInstance(t_abies_alba);
+        TaxonDescription d_abies_balsamea = TaxonDescription.NewInstance(t_abies_balsamea);
+
+        d_abies_alba.setUuid(UUID.fromString(D_ABIES_ALBA_UUID));
+        d_abies_balsamea.setUuid(UUID.fromString(D_ABIES_BALSAMEA_UUID));
+
 
-        d_abies_alba.setUuid(UUID.fromString(D_ABIES_BALSAMEA_UUID));
         // CommonTaxonName
-        d_abies_alba.addElement(CommonTaxonName.NewInstance("Weißtanne", Language.GERMAN()));
+        d_abies_alba.addElement(CommonTaxonName.NewInstance("Wei"+UTF8.SHARP_S+"tanne", Language.GERMAN()));
         d_abies_alba.addElement(CommonTaxonName.NewInstance("silver fir", Language.ENGLISH()));
+        d_abies_alba.addElement(Distribution
+                .NewInstance(
+                        germany,
+                        PresenceTerm.NATIVE()));
+        d_abies_alba.addElement(Distribution
+                .NewInstance(
+                        russia,
+                        AbsenceTerm.ABSENT()));
+
         // TextData
-        TaxonDescription d_abies_balsamea = TaxonDescription.NewInstance(t_abies_balsamea);
         d_abies_balsamea
             .addElement(TextData
                     .NewInstance(
                             "Die Balsam-Tanne (Abies balsamea) ist eine Pflanzenart aus der Gattung der Tannen (Abies). Sie wächst im nordöstlichen Nordamerika, wo sie sowohl Tief- als auch Bergland besiedelt. Sie gilt als relativ anspruchslos gegenüber dem Standort und ist frosthart. In vielen Teilen des natürlichen Verbreitungsgebietes stellt sie die Klimaxbaumart dar.",
                             Language.GERMAN(), null));
+        d_abies_balsamea
+        .addElement(CommonTaxonName
+                .NewInstance(
+                        "Balsam-Tanne",
+                        Language.GERMAN(), null));
+
+        d_abies_balsamea
+        .addElement(Distribution
+                .NewInstance(
+                        canada,
+                        PresenceTerm.PRESENT()));
+
+        d_abies_balsamea
+        .addElement(Distribution
+                .NewInstance(
+                        germany,
+                        PresenceTerm.NATIVE()));
+
         d_abies_balsamea
                 .addElement(TextData
                         .NewInstance(
                                 "Бальзам ньыв (лат. Abies balsamea) – быдмассэзлӧн пожум котырись ньыв увтырын торья вид. Ньывпуыс быдмӧ 14–20 метра вылына да овлӧ 10–60 см кыза диаметрын. Ньывпу пантасьӧ Ойвыв Америкаын.",
                                 Language.RUSSIAN(), null));
+        d_abies_balsamea
+        .addElement(CommonTaxonName
+                .NewInstance(
+                        "Бальзам ньыв",
+                        Language.RUSSIAN(), null));
+        descriptionService.saveOrUpdate(d_abies_balsamea);
+
         setComplete();
         endTransaction();
 
 
         writeDbUnitDataSetFile(new String[] {
-            "TAXONBASE", "TAXONNAMEBASE", "SYNONYMRELATIONSHIP",
+            "TAXONBASE", "TAXONNAMEBASE",
+            "SYNONYMRELATIONSHIP", "TAXONRELATIONSHIP",
             "REFERENCE", "DESCRIPTIONELEMENTBASE", "DESCRIPTIONBASE",
             "AGENTBASE", "HOMOTYPICALGROUP",
             "CLASSIFICATION", "CLASSIFICATION_TAXONNODE","TAXONNODE",
-            "LANGUAGESTRING", "DESCRIPTIONELEMENTBASE_LANGUAGESTRING" });
+            "LANGUAGESTRING", "DESCRIPTIONELEMENTBASE_LANGUAGESTRING",
+            "HIBERNATE_SEQUENCES" // IMPORTANT!!!
+            });
+
+    }
+
+    /**
+     *
+     */
+    private void refreshLuceneIndex() {
 
+//        commitAndStartNewTransaction(null);
+        commit();
+        endTransaction();
+        indexer.purge(DefaultProgressMonitor.NewInstance());
+        indexer.reindex(typesToIndex, DefaultProgressMonitor.NewInstance());
+        startNewTransaction();
+//        commitAndStartNewTransaction(null);
     }
 
     /**
@@ -1038,6 +1314,8 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
 
         logger.debug(String.format("creating %1$s random taxan with CommonName", numberOfNew));
 
+        commitAndStartNewTransaction(null);
+
         Reference sec = ReferenceFactory.newBook();
         referenceService.save(sec);
 
@@ -1057,7 +1335,29 @@ public class TaxonServiceSearchTest extends CdmTransactionalIntegrationTest {
         }
 
         commitAndStartNewTransaction(null);
+    }
 
+    private <T extends CdmBase> void logPagerRecords(Pager<SearchResult<T>> pager, Level level){
+        if(level == null){
+            level = Level.DEBUG;
+        }
+        if(logger.isEnabledFor(level)){
+            StringBuilder b = new StringBuilder();
+            b.append("\n");
+            int i = 0;
+            for(SearchResult sr : pager.getRecords()){
+                CdmBase entity = sr.getEntity();
+                b.append(" ").append(i++).append(" - ");
+                if(entity == null){
+                    b.append("NULL");
+                } else {
+                    b.append(entity.getClass().getSimpleName()).append(" : ").append(entity.toString());
+                    b.append(" [").append(entity.getUuid()).append("]");
+                }
+                b.append("\n");
+            }
+            logger.log(level, b);
+        }
     }
 
 }
diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TermServiceImplTest.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TermServiceImplTest.java
index 253a6a1ee5..ab065c366a 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TermServiceImplTest.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TermServiceImplTest.java
@@ -80,7 +80,7 @@ public class TermServiceImplTest extends CdmTransactionalIntegrationTest{
     }
 
     /**
-     * Test method for {@link eu.etaxonomy.cdm.api.service.TermServiceImpl#getTermByUuid(java.util.UUID)}.
+     * Test method for {@link eu.etaxonomy.cdm.api.service.TermServiceImpl#getContinentByUuid(java.util.UUID)}.
      */
     @Test
     /* @DataSet
diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TransmissionEngineDistributionTest.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TransmissionEngineDistributionTest.java
index d8928c103d..562844a250 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TransmissionEngineDistributionTest.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/TransmissionEngineDistributionTest.java
@@ -33,7 +33,6 @@ import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.description.PresenceTerm;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.reference.Reference;
@@ -108,19 +107,19 @@ public class TransmissionEngineDistributionTest extends CdmTransactionalIntegrat
     public void setUp() {
 
         superAreas = Arrays.asList(new NamedArea[]{
-                TdwgArea.getAreaByTdwgAbbreviation("YUG")
+        		termService.getAreaByTdwgAbbreviation("YUG")
         });
         lowerRank = Rank.SPECIES();
         upperRank = Rank.GENUS();
 
         classification = classificationService.load(CLASSIFICATION_UUID);
 
-        yug = TdwgArea.getAreaByTdwgAbbreviation("YUG");
-        yug_bh = TdwgArea.getAreaByTdwgAbbreviation("YUG-BH");
-        yug_cr = TdwgArea.getAreaByTdwgAbbreviation("YUG-CR");
-        yug_ko = TdwgArea.getAreaByTdwgAbbreviation("YUG-KO");
-        yug_ma = TdwgArea.getAreaByTdwgAbbreviation("YUG-MA");
-        yug_mn = TdwgArea.getAreaByTdwgAbbreviation("YUG-MN");
+        yug = termService.getAreaByTdwgAbbreviation("YUG");
+        yug_bh = termService.getAreaByTdwgAbbreviation("YUG-BH");
+        yug_cr = termService.getAreaByTdwgAbbreviation("YUG-CR");
+        yug_ko = termService.getAreaByTdwgAbbreviation("YUG-KO");
+        yug_ma = termService.getAreaByTdwgAbbreviation("YUG-MA");
+        yug_mn = termService.getAreaByTdwgAbbreviation("YUG-MN");
 
         engine.updatePriorities();
     }
@@ -327,11 +326,11 @@ public class TransmissionEngineDistributionTest extends CdmTransactionalIntegrat
         Classification classification = Classification.NewInstance("TestClassification");
         classification.setUuid(CLASSIFICATION_UUID);
         classificationService.save(classification);
-        TaxonNode node_lapsana = classification.addChildTaxon(t_lapsana, sec, null, null);
-        TaxonNode node_lapsana_communis = node_lapsana.addChildTaxon(t_lapsana_communis, sec, null, null);
-        node_lapsana_communis.addChildTaxon(t_lapsana_communis_communis, sec, null, null);
-        node_lapsana_communis.addChildTaxon(t_lapsana_communis_adenophora, sec, null, null);
-        node_lapsana_communis.addChildTaxon(t_lapsana_communis_alpina, sec, null, null);
+        TaxonNode node_lapsana = classification.addChildTaxon(t_lapsana, sec, null);
+        TaxonNode node_lapsana_communis = node_lapsana.addChildTaxon(t_lapsana_communis, sec, null);
+        node_lapsana_communis.addChildTaxon(t_lapsana_communis_communis, sec, null);
+        node_lapsana_communis.addChildTaxon(t_lapsana_communis_adenophora, sec, null);
+        node_lapsana_communis.addChildTaxon(t_lapsana_communis_alpina, sec, null);
         classificationService.saveOrUpdate(classification);
 
         // --- Distributions --- //
diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/Datasource.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/Datasource.java
index f1f7c00c83..5cb79a10a3 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/Datasource.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/Datasource.java
@@ -25,19 +25,22 @@ import org.springframework.transaction.TransactionStatus;
 import eu.etaxonomy.cdm.api.application.CdmApplicationController;
 import eu.etaxonomy.cdm.api.application.CdmApplicationUtils;
 import eu.etaxonomy.cdm.common.AccountStore;
+import eu.etaxonomy.cdm.common.monitor.DefaultProgressMonitor;
 import eu.etaxonomy.cdm.database.CdmDataSource;
 import eu.etaxonomy.cdm.database.CdmPersistentDataSource;
 import eu.etaxonomy.cdm.database.DataSourceNotFoundException;
 import eu.etaxonomy.cdm.database.DatabaseTypeEnum;
 import eu.etaxonomy.cdm.database.DbSchemaValidation;
 import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.database.update.CdmUpdater;
 import eu.etaxonomy.cdm.model.agent.Person;
 import eu.etaxonomy.cdm.model.common.init.TermNotFoundException;
 import eu.etaxonomy.cdm.model.description.Distribution;
+import eu.etaxonomy.cdm.model.description.FeatureNode;
+import eu.etaxonomy.cdm.model.description.FeatureTree;
 import eu.etaxonomy.cdm.model.description.PresenceTerm;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.HybridRelationshipType;
 import eu.etaxonomy.cdm.model.name.NameRelationshipType;
@@ -45,7 +48,9 @@ import eu.etaxonomy.cdm.model.name.Rank;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
+import eu.etaxonomy.cdm.model.taxon.Classification;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
+import eu.etaxonomy.cdm.model.taxon.TaxonNode;
 
 public class Datasource {
 	private static final Logger logger = Logger.getLogger(Datasource.class);
@@ -53,18 +58,79 @@ public class Datasource {
 	
 	private void testNewConfigControler(){
 		List<CdmPersistentDataSource> lsDataSources = CdmPersistentDataSource.getAllDataSources();
+		DbSchemaValidation schema = DbSchemaValidation.VALIDATE;
 		System.out.println(lsDataSources);
 //		CdmPersistentDataSource dataSource = lsDataSources.get(0);
 //		DatabaseTypeEnum dbType = DatabaseTypeEnum.MySQL;
+		
 		String server = "localhost";
-		String database = "cdm_test";
+//		String database = "cdm_test";
+		String database = "test";
 		String username = "edit";
 		ICdmDataSource dataSource = CdmDataSource.NewMySqlInstance(server, database, username, AccountStore.readOrStorePassword(server, database, username, null));
-//		CdmPersistentDataSource.save(dataSource.getName(), dataSource);
+		
+//		//SQLServer
+//		database = "CDMTest";
+//		int port = 1433;
+//		username = "pesiexport";
+////		dataSource = CdmDataSource.NewSqlServer2005Instance(server, database, port, username, AccountStore.readOrStorePassword(server, database, username, null));
+//		
+//		//H2
+//		username = "sa";
+////		dataSource = CdmDataSource.NewH2EmbeddedInstance(database, username, "sa", NomenclaturalCode.ICNAFP);
+		
+		
+		CdmUpdater updater = new CdmUpdater();
+		updater.updateToCurrentVersion(dataSource, DefaultProgressMonitor.NewInstance());
+		
+		
+		//CdmPersistentDataSource.save(dataSource.getName(), dataSource);
 		CdmApplicationController appCtr;
-		appCtr = CdmApplicationController.NewInstance(dataSource, DbSchemaValidation.CREATE);
+		appCtr = CdmApplicationController.NewInstance(dataSource,schema);
+		
+//		insertSomeData(appCtr);
+		
+		
+		
 		appCtr.close();
 	}
+
+	private void insertSomeData(CdmApplicationController appCtr) {
+		Classification cl = Classification.NewInstance("myClass");
+		TaxonNode node1 = cl.addChildTaxon(Taxon.NewInstance(BotanicalName.NewInstance(null), null), null, null);
+		appCtr.getClassificationService().save(cl);
+		
+		Taxon t2 = Taxon.NewInstance(null, null);
+		t2.setTitleCache("Taxon2", true);
+		TaxonNode node2 = node1.addChildTaxon(t2, null, null);
+		
+		Taxon t3 = Taxon.NewInstance(null, null);
+		t3.setTitleCache("Taxon3", true);
+		TaxonNode node3 = node1.addChildTaxon(t3, 0, null, null);
+		
+		appCtr.getTaxonNodeService().saveOrUpdate(node1);
+		
+		cl.addChildNode(node3, 0, null, null);
+		appCtr.getTaxonNodeService().saveOrUpdate(node3);
+		appCtr.getClassificationService().saveOrUpdate(cl);
+		
+		FeatureTree ft1 = FeatureTree.NewInstance();
+		FeatureNode fn1 = FeatureNode.NewInstance(null);
+		ft1.getRoot().addChild(fn1);
+		appCtr.getFeatureNodeService().save(fn1);
+		
+		FeatureNode fn2 = FeatureNode.NewInstance(null);
+		fn1.addChild(fn2);
+		
+		FeatureNode fn3 = FeatureNode.NewInstance(null);
+		fn1.addChild(fn2, 0);
+		
+		appCtr.getFeatureNodeService().saveOrUpdate(fn1);
+		
+		ft1.getRoot().addChild(fn3, 0);
+		appCtr.getFeatureNodeService().saveOrUpdate(fn3);
+		appCtr.getFeatureTreeService().saveOrUpdate(ft1);
+	}
 	
 	private void testDatabaseChange() throws DataSourceNotFoundException{
 		CdmApplicationController appCtr;
@@ -95,41 +161,6 @@ public class Datasource {
 		appCtr.close();
 	}
 
-	private void testSqlServer(){
-		DbSchemaValidation validation = DbSchemaValidation.CREATE;
-		CdmDataSource ds = 
-			CdmDataSource.NewSqlServer2005Instance("LENOVO-T61", "NielsTest", -1, "Niels", "test", null);
-			//CdmDataSource.NewH2EmbeddedInstance("cdm", "sa", "");
-//		ds =
-//			 CdmPersistentDataSource.NewInstance("localH2");
-		try {
-			CdmApplicationController appCtr = CdmApplicationController.NewInstance(ds, validation);
-			String sql = "SELECT name, id FROM sys.sysobjects WHERE (xtype = 'U')"; //all tables
-			ResultSet rs = ds.executeQuery(sql);
-			while (rs.next()){
-				String tableName = rs.getString("name");
-				long tableId = rs.getLong("id");
-				sql = "SELECT name FROM sys.sysobjects WHERE xtype='F' and parent_obj = " +  tableId;//get foreignkeys
-				ResultSet rsFk = ds.executeQuery(sql);
-				while (rsFk.next()){
-					String fk = rsFk.getString("name");
-					sql = " ALTER TABLE "+tableName+" DROP CONSTRAINT "+fk + "";
-					ds.executeUpdate(sql);
-				}
-				
-			}
-			
-			Person agent = Person.NewInstance();
-			appCtr.getAgentService().save(agent);
-			TaxonNameBase<?,?> tn = BotanicalName.NewInstance(null);
-			appCtr.getNameService().save(tn);
-			appCtr.close();
-		} catch (SQLException e) {
-			// TODO Auto-generated catch block
-			e.printStackTrace();
-		}
-	}
-
 	private void testSqlServer2005(){
 		DatabaseTypeEnum databaseTypeEnum = DatabaseTypeEnum.SqlServer2005;
 		String server = "LAPTOPHP";
@@ -211,7 +242,7 @@ public class Datasource {
 			Taxon taxon = Taxon.NewInstance(name, ref);
 			TaxonDescription description = TaxonDescription.NewInstance();
 			taxon.addDescription(description);
-			NamedArea area1 = TdwgArea.getAreaByTdwgAbbreviation("GER");
+			NamedArea area1 = appCtr.getTermService().getAreaByTdwgAbbreviation("GER");
 			Distribution distribution = Distribution.NewInstance(area1, PresenceTerm.PRESENT());
 			description.addElement(distribution);
 			
diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestC3P0Configuration.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestC3P0Configuration.java
index 29f94929f3..a17f7e59e7 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestC3P0Configuration.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestC3P0Configuration.java
@@ -43,7 +43,7 @@ public class TestC3P0Configuration{
 
 	@Before
 	public void setup() throws DataSourceNotFoundException, TermNotFoundException{
-		CdmDataSource dataSource = CdmDataSource.NewMySqlInstance("localhost", "test", -1, "edit", "wp5", NomenclaturalCode.ICBN);
+		CdmDataSource dataSource = CdmDataSource.NewMySqlInstance("localhost", "test", -1, "edit", "wp5", NomenclaturalCode.ICNAFP);
 		appController = CdmApplicationController.NewInstance(dataSource, DbSchemaValidation.CREATE);
 	}
 
diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestDatabase.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestDatabase.java
index a2815d83cb..fe4cab94c4 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestDatabase.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestDatabase.java
@@ -270,7 +270,7 @@ public class TestDatabase {
 
 	public void testLoadedAnnotationGetAnnotatedObjectCall(){
 		String password = CdmUtils.readInputLine("Password: ");
-		ICdmDataSource dataSource = CdmDataSource.NewMySqlInstance("192.168.2.10", "cdm_test_niels2", 3306, "edit", password, NomenclaturalCode.ICBN);
+		ICdmDataSource dataSource = CdmDataSource.NewMySqlInstance("192.168.2.10", "cdm_test_niels2", 3306, "edit", password, NomenclaturalCode.ICNAFP);
 
 		CdmApplicationController appCtr = CdmApplicationController.NewInstance(dataSource, DbSchemaValidation.UPDATE);
 
diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestLocationServiceImpl.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestLocationServiceImpl.java
index 82fcad0e27..654f1ea5a0 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestLocationServiceImpl.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestLocationServiceImpl.java
@@ -57,8 +57,14 @@ public class TestLocationServiceImpl  extends CdmIntegrationTest{
 
 	@Ignore
 	@Test
-	public void testGetTopLevelWaterbodyOrCoutryAreas(){
-		locationService.getTopLevelNamedAreasByVocabularyType(NamedAreaVocabularyType.WATERBODY_OR_COUNTRY);
+	public void testGetTopLevelCoutryAreas(){
+		locationService.getTopLevelNamedAreasByVocabularyType(NamedAreaVocabularyType.COUNTRY);
+	}
+
+	@Ignore
+	@Test
+	public void testGetTopLevelWaterbodyAreas(){
+		locationService.getTopLevelNamedAreasByVocabularyType(NamedAreaVocabularyType.WATERBODY);
 	}
 
 	public void testNewDatasourceClass(){
diff --git a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/integration/TestTaxonServices.java b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/integration/TestTaxonServices.java
index b7ab25eff1..373a984d77 100644
--- a/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/integration/TestTaxonServices.java
+++ b/cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/integration/TestTaxonServices.java
@@ -21,7 +21,7 @@ import eu.etaxonomy.cdm.model.agent.AgentBase;
 import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.location.NamedArea;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.NameRelationship;
 import eu.etaxonomy.cdm.model.name.NameRelationshipType;
@@ -151,7 +151,7 @@ public class TestTaxonServices {
 		NamedArea namedArea = NamedArea.NewInstance("MyTerm", "MyLabel", "MyLabelAbbr");
 		UUID naid = appCtr.getTermService().save(namedArea);
 		
-		WaterbodyOrCountry woc = WaterbodyOrCountry.NewInstance("NAR", "Narnia", "NN");
+		Country woc = Country.NewInstance("NAR", "Narnia", "NN");
 		UUID wocid = appCtr.getTermService().save(woc);
 		
 		DefinedTermBase dtb = appCtr.getTermService().find(naid);
@@ -163,7 +163,7 @@ public class TestTaxonServices {
 		dtb = appCtr.getTermService().find(wocid);
 //		dtb = 
 //			appCtr.getTermService().getTermByUuid(UUID.fromString("7cc278aa-b42a-4b5f-b7ad-0cbab0730da8"));
-		logger.debug("WaterbodyOrCountry: " + dtb.toString());
+		logger.debug("Country: " + dtb.toString());
 
 		appCtr.commitTransaction(txStatus);
 		logger.info("End testing createNamedArea()");
